/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.bc.http.listeners;

import java.util.HashMap;
import java.util.Map;

/**
 * This descriptor handles information for http requests
 * @author mcarpentier - EBM Websourcing
 */
public class HttpRequestDescriptor {

    /**
     * method (GET or POST)
     */
    private String method;

    /**
     * request parameters
     */
    private Map<String, String> parameters;

    /**
     * Requested url
     */
    private String url;

    /**
     * optional suffix
     */
    private String suffix;

    /**
     * constructor
     */
    public HttpRequestDescriptor() {
        super();
    }

    /**
     * @param parameter the parameter key to add
     * @param value the parameter value to add
     */
    public final void addParameter(final String parameter, final String value) {
        if (this.getParameters() == null) {
            this.setParameters(new HashMap<String, String>());
        }
        this.getParameters().put(parameter, value);
    }

    public final String getMethod() {
        return this.method;
    }

    public final Map<String, String> getParameters() {
        return this.parameters;
    }

    public final String getUrl() {
        return this.url;
    }

    public final void setMethod(final String method) {
        this.method = method;
    }

    public final void setParameters(final Map<String, String> parameters) {
        this.parameters = parameters;
    }

    public final void setUrl(final String url) {
        this.url = url;
    }

    public final String getSuffix() {
        return this.suffix;
    }

    public final void setSuffix(final String suffix) {
        this.suffix = suffix;
    }

}
