/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.bc.http.util;

import java.io.IOException;
import java.io.StringReader;

import javax.jbi.JBIException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * Some usefull functions to process Http messages
 * @author mcarpentier - EBM Websourcing
 */
public class HttpUtil {

    /**
     * singleton
     */
    private static HttpUtil INSTANCE;

    /**
     * @return a single instance of the class
     */
    public static HttpUtil getInstance() {
        if (INSTANCE == null) {
            INSTANCE = new HttpUtil();
        }
        return INSTANCE;
    }

    /**
     * @param xml
     *            the xml string to analyze
     * @return true if the string is well formed.
     * @throws JBIException
     *             if an error occurs while analyzing string
     */
    public final boolean isXmlWellFormed(final String xml) throws JBIException {
        try {
            final DocumentBuilderFactory factory = DocumentBuilderFactory
                    .newInstance();
            factory.newDocumentBuilder();

            DocumentBuilder parser;
            parser = factory.newDocumentBuilder();
            final InputSource is = new InputSource(new StringReader(xml));
            final Document document = parser.parse(is);
        } catch (final ParserConfigurationException e) {
            return false;
        } catch (final SAXException e) {
            return false;
        } catch (final IOException e) {
            final String msg = "Error while analyzing XML String";
            throw new JBIException(msg, e);
        }
        return true;
    }
}
